import {
  I18n,
} from '@zeedhi/core';

export class Utilities {
  public static dateString(ptBrDate, showDay = true, showMonth = true,
    showYear = true, shortMonth = true, showTime = false) {
    if (ptBrDate) {
      const parts = ptBrDate.split(' ');
      const date = parts[0];
      const time = parts[1];
      const dateParts = date.split('/');
      const day = parseInt(dateParts[0], 10);
      const month = parseInt(dateParts[1], 10);
      const year = parseInt(dateParts[2], 10);
      const label = (shortMonth) ? 'monthShort' : 'month';
      const monthString = I18n.translate(`utilities::${label}${month}`);
      const result = [];
      if (showDay) {
        result.push(day);
      }
      if (showMonth) {
        result.push(monthString);
      }
      if (showYear) {
        result.push(year);
      }
      const dateStr = result.join('/');
      if (showTime) {
        return `${dateStr} ${time}`;
      }
      return dateStr;
    }
    return '';
  }

  public static dateTimeString(ptBrDate, shortMonth = true) {
    return this.dateString(ptBrDate, true, true, true, shortMonth, true);
  }

  public static monthString(ptBrDate, shortMonth = false) {
    return this.dateString(ptBrDate, false, true, true, shortMonth, false);
  }
}
