import Vue from 'vue';
import Zeedhi from '@zeedhi/vue';
import ZeedhiComponents from '@zeedhi/vuetify';
import { Icons } from '@zeedhi/common';
import { Messages } from '@zeedhi/core';
import controllers from '../controllers';
import config from '../config/config';
import '@zeedhi/common/dist/style.css';
import '@zeedhi/vuetify/dist/zd-style.css';
import vuetify from './vuetify';
import messages from '../../assets/json/messages.json';

Icons.addIcons({
  iconName: 'mdi-icon-id',
  cart: 'mdi-cart',
  cartOff: 'mdi-cart-off',
  messageAlert: 'mdi-message-alert',
  tableEdit: 'mdi-table-edit',
});

Vue.use(Zeedhi, {
  controllers,
  config,
});
Vue.use(ZeedhiComponents);

vuetify.framework.icons.values = Icons.getIcons() as any;

Messages.add({
  'pt-BR': {
    translation: {
      ...messages,
    },
  },
  'es-CL': {
    translation: {
      KEY: 'valor',
    },
  },
  'es-CO': {
    translation: {
      KEY: 'valor',
    },
  },
  'es-ES': {
    translation: {
      KEY: 'valor',
    },
  },
  'en-US': {
    translation: {
      KEY: 'value',
    },
  },
});
