package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

public class ElaboraCardapioPage extends PageBase {

    By ClicaMenu = By.xpath("//*[@type = 'button']");
    By usernameLoginInfoTextArea = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By ClicaPlanejamento = By.xpath("//*[@class = 'menu-link']//*[contains(text(),'Planejamento')]");
    By ClicaCardapio = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[2]/nav/ul/li[1]/ul/li[2]/ul/li[1]/span/span[3]");
    By ClicaElaboracao = By.xpath("//ul[@class = 'sub-menu']//span[@class = 'menu-link']//span[contains(text(),'Elaboração do Cardápio')]");
    By textAreaConfirma = By.xpath("//div[contains(text(),'Seleção do Cardápio')]");
    By btnLimpaCampo = By.xpath("//div[@id = 'NMFILIAL']//span[@class = 'zh-icon zh-icon-close-x zh-icon-no-border']");
    By lupaFilial = By.xpath("//*[@id = 'NMFILIAL']//span[@class = 'zh-icon zh-icon-search zh-icon-no-border']");
    By lupaFiltro = By.xpath("//*[@id='popup']//span[@class = 'action-icon search-action-icon zh-icon zh-icon-search zh-icon-no-border zh-icon-color-white']");
    By msgAlerta = By.xpath("//footer[@class = 'zh-footer-alert']//span[contains(text(),'OK')]");
    By confirmaFilial = By.xpath("//*[@id='grid-9000']/div[2]/div/div/div[1]");
    By btnConfirmar = By.xpath("//*[@id='footer']/div[3]/ul/li");
    By msgEsperada = By.xpath("//*[contains(text(),'COMENSAIS')]");
    By filtroServico = By.xpath("//div[@id = 'NMSERVICO']//span[@class = 'zh-icon zh-icon-search zh-icon-no-border']");
    By informaServico = By.xpath("//*[@id= 'popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By confirmaServico = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]");
    By preencheFilial = By.xpath("//*[@id= 'popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");

    By campoData = By.xpath("//div[@id = 'dataCardapio']");
    By avancaPeriodo = By.xpath("//div[@class = 'arrow-right zh-icon zh-icon-forward zh-icon-no-border']");
    By periodoCardapio = By.xpath("//div[@class= 'month']//*[contains(text(),'Abr')]");

    //campo custo planejado
    By campoCustoPla = By.xpath("//div[@id = 'NMCUSTOPLANEJADO']");
    By lupaCustoPla = By.xpath("//*[@id='NMCUSTOPLANEJADO']/span");
    By informaCustoPla = By.xpath("//*[@id='popup']/span/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaCustoPla = By.xpath("//*[@id='popup']/span/section/section/section/div/div[1]/ul/li[2]/div/div/span");

    //campo custo realizado
    By campoCustoReal = By.xpath("//div[@id= 'NMCUSTOREALIZADO']");
    By lupaCustoReal = By.xpath("//div[@id= 'NMCUSTOREALIZADO']/span");
    By informaCustoReal = By.xpath("//*[@id='popup']/span/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaCustoReal = By.xpath("//*[@id='popup']/span/section/section/section/div/div[1]/ul/li[2]/div/div/span");
    By exibeCustoCardapio = By.xpath("//div[@data-zh-id='3931100361415493489953']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By dtCardapio = By.xpath("/html/body/span[1]/section/section/div[2]/section[2]/div/section/section/div/form/section[2]/div/div[3]/div[1]/div/div");
    By dtReferencia = By.xpath("/html/body/span[1]/section/section/div[2]/section[2]/div/section/section/div/form/section[2]/div/div[3]/div[1]/div/div[3]/label/div");
    By limpaDtReferencia = By.xpath("//div[@class = 'close-button']");
    By inputDtReferencia = By.xpath("//input[@name = 'dataReferencia']");

    //Elaborando Cardápio
    By tipoPrato01 = By.xpath("//*[@id='grid-21154635373500446320972']/div[2]/div/div[1]/div[3]");
    By tipoPrato02 = By.xpath("//*[@id='grid-21154635373500446320972']/div[2]/div/div[1]/div[4]");
    By tipoPrato03 = By.xpath("//*[@id='grid-21154635373500446320972']/div[2]/div/div[1]/div[5]");
    By tipoPRato04 = By.xpath("//*[@id='grid-21154635373500446320972']/div[2]/div/div[1]/div[3]");
    By tipoPrato05 = By.xpath("//*[@id='grid-21154635373500446320972']/div[2]/div/div[2]/div[3]");
    By nmPrato = By.xpath("//*[@id='PRATOINI']");
    By clicarGrid = By.xpath("//div[@id = 'grid-21154635372457805457423']//div[@class = 'body-content']");
    By clicaPrato = By.xpath("//*[@id='grid-21154635374273353301405']/div[2]/div/div");
    By copiarSubsPratoSeg = By.xpath("//*[@id='masonry-item-21154635371598783833433']/div/form/section[2]/div/div[1]/div[2]/div/label/div");
    By copiarSubsPratoTer = By.xpath("//*[@id='masonry-item-21154635371598783833433']/div/form/section[2]/div/div[1]/div[3]/div/label/div");
    By copiarSubsPratoQua = By.xpath("//*[@id='masonry-item-21154635371598783833433']/div/form/section[2]/div/div[1]/div[4]/div/label/div");
    By copiarSubsPratoQuin = By.xpath("//*[@id='masonry-item-21154635371598783833433']/div/form/section[2]/div/div[2]/div[1]/div/label/div");
    By copiarSubsPratoSex = By.xpath("//*[@id='masonry-item-21154635371598783833433']/div/form/section[2]/div/div[2]/div[2]/div/label/div");
    By btnSalvar = By.xpath("//span[text() = 'Salvar']");
    By btnAcoes = By.xpath("//li[@class='more-actions zh-ripple-effect']");
    By btnCancelar = By.xpath("//*[@id='footer']/div[1]/ul/li");

    By analiseCor = By.xpath("//span[text() = 'Análise de Cor']");


    //Analise de Custo
    By analiseCusto = By.xpath("//span[text() =  'Análise de Custos']");
    By abaPlanejado = By.xpath("//a[text() = 'Planejado']");
    By abaRealizado = By.xpath("//a[text() =  'Realizado']");
    By abaAcompanhamento = By.xpath("//a[text() =  'Acompanhamento']");
    By abaProdCustoZero = By.xpath("//a[text() =  'Produtos Custo Zero']");
    By clicaDiaAnalise = By.xpath("//*[@id='grid-158134869238991976091062']/div[2]/div/div[1]");
    By materiaPrima = By.xpath("//a[text() = 'Matéria Prima']");
    By consumoPorServico = By.xpath("//a[text() = 'Consumo por Serviço']");
    By clicaTipopratoConsumo = By.xpath("//div[@ id='grid-15813486925486828631110']//div[@class='tr cell1']");
    By clicaTipoPratoConsumo = By.xpath("//div[@ id='grid-15813486925486828631110']//div[@class='tr cell2 colorline']");
    By clicaPratoMateriaPrima = By.xpath("//*[@id='grid-158134869215106118231064']/div[2]/div/div");


    //Atualiza Data de Referência
    By atualizaDataRef = By.xpath("//span[text() = 'Atualizar Data de Referência para Custos']");
    By btnTodos = By.xpath("//span[@class = 'zh-icon zh-icon-checked zh-icon-no-border']");
    By campoServico = By.xpath("//*[@id='NMSERVICO']");
    By confirmServico = By.xpath("//span[@data-ng-if='!row.__group']");
    By btnOk = By.xpath("//span[text() = 'Ok']");
    By limpaDataRef = By.xpath("//div[@class = 'close-button']");
    By calendarDtRef = By.xpath("//span[@class = 'zh-icon zh-icon-calendar zh-icon-no-border']");
    By selecionaDtReferencia = By.xpath("//div[text()= '19']");
    By btnAtualizar = By.xpath("//*[@id='footer']/div[3]/ul/li/a/span");
    By confirmaDataReferencia = By.xpath("//footer[@class = 'zh-footer-alert']//span[text() = 'Sim']");
    By botaoOkMsg = By.xpath("//footer[@class = 'zh-footer-alert']//span[text() = 'OK']");

    //Atualizar Data de Referência para Recálculo de Custos
    By btnAtualizaDtRecalculoCusto = By.xpath("//span[text() = 'Atualizar Data de Referência para Recálculo de Custos']");

    // Consulta Nutrientes
    By btnConsulaNutriente = By.xpath("//span[text() = 'Consultar Nutrientes']");
    By btnCalculaNutriente = By.xpath("//li[@data-zh-id='82955748940826254151552']//div[@class = 'zh-test-box']");
    By btnVoltar = By.xpath("//*[@id='footer']/div[1]/ul/li/a/span");
    By btnCalendario = By.xpath("//li[@data-zh-id='82955748928579975681556']//div[@class = 'zh-test-box']");
    By diaCalculoNutriente = By.xpath("//section[@class = 'popup-content']//span[text() = '03/04/2024']");

    // Copia Pratos e Comensais
    By btnCopiaPratoComensais = By.xpath("//span[text() = 'Copiar Pratos e Comensais']");
    By limpaCampoServico = By.xpath("//div[@class = 'zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMPRATO zh-text-align-left']");
    By lupaPratoOrigem = By.xpath("//span[@zh-icon='no-border search']");
    By informaPrato = By.xpath("//*[@id= 'popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaPrato = By.xpath("//*[@id='grid-9000']/div[2]/div/div");
    By checkBoxSobreporPratos = By.xpath("//div[@data-zh-id='21154635373442535691254']//span[@class = 'zh-icon zh-icon-check");
    By comensaisSeg = By.xpath("//input[@id = 'COMENSAISSEG']");
    By comensaisTer = By.xpath("//input[@id = 'COMENSAISTER']");
    By comensaisSQuar = By.xpath("//input[@id = 'COMENSAISQUA']");
    By comensaisQuin = By.xpath("//input[@id = 'COMENSAISQUI']");
    By comensaisSex = By.xpath("//input[@id = 'COMENSAISSEX']");
    By comensaisSab = By.xpath("//input[@id = 'COMENSAISSAB']");
    By comensaisDom = By.xpath("//input[@id = 'COMENSAISDOM']");
    By comensaisFer = By.xpath("//input[@id = 'COMENSAISFER']");
    By btnCopiarPratos = By.xpath("//li[@data-zh-id='21154635373354322134257']");
    By btnCopiaComensais = By.xpath("//li[@data-zh-id='2115463537806145373259']");
    By confirmaMensagem = By.xpath("//*[@class = 'zh-footer-alert']");


    //Exportar Cardápio
    By btnExportarCardapio = By.xpath("//span[text() = 'Exportar Cardápio']");
    By btnProximoMes = By.xpath("//div[@class = 'arrow-right zh-icon zh-icon-forward zh-icon-no-border']");
    By periodoInicial = By.xpath("//div[@class = 'day']//div[text() = '1']");
    By periodoFinal = By.xpath("//div[@class = 'day']//div[text() = '30']");
    By dtInicialExportacao = By.xpath("//input[@id = 'DTINTERVAL_START']");
    By dtFinalExportacao = By.xpath("//input[@id = 'DTINTERVAL_END']");
    By checkBoxCopiarComOrig = By.xpath("//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By radioButtonSobrepor = By.xpath("//label[@for = 'radio-ACRESCSOBRE-S']//div[@class = 'zh-circle mousetrap zh-ripple-effect']");
    By campoGrupo = By.xpath("//div[@id= 'NMGRUPSERV']");
    By marcaServicoDestino = By.xpath("//*[@id='grid-2115463537811085471318']/div[2]/div/div[1]/div[1]/span");
    By btnExportar = By.xpath("//*[text() ='Exportar']");
    By limpaFiltroServico = By.xpath("//div[@id = 'NMSERVICO']//span[@zh-icon='no-border close-x']");
    By clicaAno = By.xpath("//h3[@class = 'calendar-heading']");
    By selecionaMesDestinoExportacao = By.xpath("//div[text() = 'Abr']");



    //Importar Cardápio do Dia
    By btnImportarCardapio = By.xpath("//span[text() = 'Importar Cardápio do Dia']");
    By informaFilial = By.xpath("//*[@id= 'popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaFilial = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]");
    By dtInicialOrigem = By.xpath("//input[@id = 'DATAORIGEMINICIAL']");
    By dtFinalOrigem = By.xpath("//input[@id = 'DATAORIGEMFINAL']");
    By dtDestino = By.xpath("//input[@id = 'DATADESTINO']");
    By radioSobrepor = By.xpath("//label[@for = 'radio-MONTAGEM-S']//div[@class = 'zh-circle mousetrap zh-ripple-effect']");
    By btnFiltrar = By.xpath("//section[@class= 'popup-container']//div[@id = 'footer']//li[@data-zh-id='97373962911923200311585']//span[text() = 'Filtrar']");
    By btnImportar = By.xpath("//li[@data-zh-id='9737396299038390791597']");

    //Importa tipo de prato

    By btnImportaTipoPrato = By.xpath("//span[text() = 'Importar Tipo de Prato']");
    By campoMesCardapio = By.xpath("//div[@id = 'dataCardapio']");
    By mesCardapio = By.xpath("//div[text() = 'Abr']");
    By dtInicioDestino = By.xpath("//input[@id = 'DTINIDEST']");
    By ckeckBoxCopiaComCardapioOrig = By.xpath("//label[@class = 'zh-box-label']//span[@zh-icon = 'checked no-border']");
    By tipoPratoAcrescentar = By.xpath("//div[@name = 'tipoPratoAcrescentar']");
    By marcaTipoPrato = By.xpath("//*[@id='grid-9999']/div[1]/div/div/div[1]/div");
    By btnOK = By.xpath("//*[@id='footer']//div[@class = 'zh-footer-right']");
    By btnImportarTipoPrato = By.xpath("//span[text() = 'Importar']");
    By confirmaImportacao = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[text() = 'Sim']");


    //Excluir Cadápio no Período
    By btnExcluirCardapioPeriodo = By.xpath("//span[text() = 'Excluir Cardápio no Período']");
    By limpaDataInicial = By.xpath("//div[@class = 'zh-select-date zh-field-dataInicial']//div[@class = 'close-button']");
    By limpaDataFinal = By.xpath("//div[@class = 'zh-select-date zh-field-dataFinal']//div[@class = 'close-button']");
    By dataInicial = By.xpath("//input[@id = 'dataInicial']");
    By dataFinal = By.xpath("//input[@id = 'dataFinal']");
    By listaTipoPrato = By.xpath("//div[@name = 'listaTipoPrato']");
    By checkTipoPratoTodos = By.xpath("//div[@class='zh-theader zh-ripple-effect']");
    By btnExcluir = By.xpath("//li[@data-zh-id='211546353742575670181035']//span[text() = 'Excluir']");
    By confirmaExclusaoCardPeriodo = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[text() = 'Sim']");


    //COnfigurar Cardápio
    By btnConfigurarCardapio = By.xpath("//span[text() = 'Configurar Cardápio']");
    By tipoDePrato1 = By.xpath("/html/body/span[1]/section/section/div[2]/section[2]/div/section/section[2]/section/div/div/div/div/ul/li[4]/div/span[1]/span[1]");
    By tipoDePrato2 = By.xpath("/html/body/span[1]/section/section/div[2]/section[2]/div/section/section[2]/section/div/div/div/div/ul/li[5]/div/span[1]/span[1]");
    By tipoDePrato3 = By.xpath("/html/body/span[1]/section/section/div[2]/section[2]/div/section/section[2]/section/div/div/div/div/ul/li[6]/div/span[1]/span[1]");
    By btnExcluirTipoPratos = By.xpath("//li[@data-zh-id='149407725714901091541629']");
    By btnConfirma = By.xpath("//span[text() = 'Confirmar']");

    //Inverter Pratos
    By btnInverterPrato = By.xpath("//span[text() = 'Inverter Prato']");
    By dtPratoOrigem = By.xpath("//input[@id = 'dataCardapioOrig']");
    By dtPratoDestino = By.xpath("//input[@id = 'dataCardapioDest']");
    By ckeckBoxManterComensalDia = By.xpath("//label[@class = 'zh-box-label']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By btnInverter = By.xpath("//span[text() = 'Inverter']");

    //Excluir Prato
    By btnExcluirPrato = By.xpath("//li[@data-zh-id='21154635371281162229416']");
    By btnConfirmaExclusao = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[text() = 'Sim']");

    //Informação nutricional
    By btnInformacaoNutricional = By.xpath("//li[@data-zh-id='21154635371738403281418']");

    //Revisar Receita
    By btnRevisarReceita = By.xpath("//li[@data-zh-id='21154635371785637359420']");
    By btnReceitaPadrao = By.xpath("//a[text() = 'Receita Padrão']");
    By btnReceitaLocal = By.xpath("//a[text() = 'Receita Local']");
    By btnReceitaPorServico = By.xpath("//a[text() = 'Receita por Serviço']");
    By btnImportarReceita = By.xpath("//li[@data-zh-id='2115463537589168631518']");
    By btnImportarReceitaServico = By.xpath("//li[@data-zh-id='21154635372393255248520']");
    By tipoReceita = By.xpath("//span[@class = 'current']");
    By opcaoPadrao = By.xpath("//li[text() = 'Padrão']");
    By opcaoLocal = By.xpath("//li[text() = 'Local']");
    By opcaoServico = By.xpath("//li[text() = 'Serviço']");
    By campoUnidade = By.xpath("//*[@id='NMFILIAL']/input");
    By defineServico = By.xpath("//div[@class = 'zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMSERVICO zh-text-align-left']");

    By filialOrigem = By.xpath("//span[@data-item-identifier='9999 | DEPOSITO BC 129']");
    By btnRealizaImportacao = By.xpath("//li[@data-zh-id='21154635371080349298656']");
    By importacaoAcrescentar = By.xpath("//footer[@class = 'zh-footer-alert']//span[text() = 'Acrescentar']");
    By importacaoSobrepor = By.xpath("//footer[@class = 'zh-footer-alert']//span[text() = 'Sobrepor']");
    By importacaoCancelar = By.xpath("//footer[@class = 'zh-footer-alert']//span[text() = 'Cancelar']");
    By validaPratoCardapio = By.xpath("//div[@class = 'tr cell1']//span[text() = '100 - ARROZ TEMPEREADO']");

    public void clicaMenu() {
        waitForElement(ClicaMenu);
        waitForElement(usernameLoginInfoTextArea);
        click(ClicaMenu);
    }

    public void clicaPlanejamento() {
        click(ClicaPlanejamento);
    }

    public void clicaCardapio() {
        click(ClicaCardapio);
    }

    public void clicaElaboracao() {
        click(ClicaElaboracao);
    }

    public void clicarCampoFilial() {
        // waitForElement(textAreaConfirma);
        click(btnLimpaCampo);
        click(msgAlerta);
        click(lupaFilial);
        tempo();
        click(lupaFiltro);

    }

    public void informaFilial(String filial) {
        sendKeys(preencheFilial, filial);
        //Aguardando filial carregar no filtro
        tempo();
        click(confirmaFilial);
        tempo();
    }

    public void filtrarServico(String CDSERVICO) {
        click(filtroServico);
        sendKeys(informaServico, CDSERVICO);
        tempo();
        click(confirmaServico);
    }

    public void definePeriodo() {
        click(campoData);
        click(avancaPeriodo);
        click(periodoCardapio);
        tempo();
    }

    public void custoCardapioPla() {
        click(campoCustoPla);
        click(lupaCustoPla);
        sendKeys(informaCustoPla, "Custo Médio Bruto Atual");
        tempo();
        click(selecionaCustoPla);
        tempo();
    }

    public void custoCardapioReal() {
        click(campoCustoReal);
        click(lupaCustoReal);
        sendKeys(informaCustoReal, "Custo Médio Bruto Atual");
        tempo();
        click(selecionaCustoReal);


    }

    public void dataReferencia(String DTREFERENCIA) {
        //  click(exibeCustoCardapio);
        //click(dtCardapio);
        click(dtReferencia);
        click(limpaDtReferencia);
        click(inputDtReferencia);
        sendKeys(inputDtReferencia, DTREFERENCIA);
    }

    public void confirmaFiltro() {
        click(btnConfirmar);
    }

    public String mensagemEsperada() {
        return getText(msgEsperada);
    }

    public void elaboraCardapio(String NMPRATO1, String NMPRATO2, String NMPRATO3) {
        duploClique(tipoPrato01);
        tempo();
        click(nmPrato);
        sendKeys(nmPrato, NMPRATO1);
        click(clicarGrid);
        click(clicaPrato);
        copiaSubsPratoSalvar();
        duploClique(tipoPrato02);
        click(nmPrato);
        sendKeys(nmPrato, NMPRATO2);
        click(clicarGrid);
        click(clicaPrato);
        copiaSubsPratoSalvar();
        duploClique(tipoPrato03);
        tempo();
        click(nmPrato);
        tempo();
        sendKeys(nmPrato, NMPRATO3);
        tempo();
        click(clicarGrid);
        tempo();
        click(clicaPrato);
        copiaSubsPratoSalvar();
        tempo();
        //Barra de Rolagem
        ScrollTela();
        tempo();
    }

    public void copiaSubsPratoSalvar() {
        click(copiarSubsPratoSeg);
        click(copiarSubsPratoTer);
        click(copiarSubsPratoQua);
        click(copiarSubsPratoQuin);
        click(copiarSubsPratoSex);
        click(btnSalvar);
        tempo();
        tempo();
    }

    public void analisarCorCardapio(){
    tempo();
    click(btnAcoes);
    tempo();
    click(analiseCor);
    tempo();
    javaScriptExecutor.executeScript("document.querySelector('#grid-21154635373500446320972 > div.body').scroll(0,-200)");
    tempo();
    tempo();

    }

    public void analiseCustos() {
        click(btnAcoes);
        tempo();
        click(analiseCusto);
        tempo();
        tempo();
        ScrollTelaAnaliseCusto();
        click(abaRealizado);
        tempo();
       /* tempo();
        ScrollTelaAnaliseCusto();*/
        click(abaAcompanhamento);
        tempo();
        tempo();
        scrollAbaAcompanhamento();
        click(abaProdCustoZero);
        tempo();
        tempo();
        scrollAbaProdutoCustoZero();
        tempo();
        click(abaPlanejado);
        tempo();
        click(clicaDiaAnalise);
        tempo();
        click(consumoPorServico);
        tempo();
        click(clicaTipopratoConsumo);
        tempo();
        click(btnVoltar);
        tempo();
        click(clicaTipoPratoConsumo);
        tempo();
        click(btnVoltar);
        tempo();
        click(materiaPrima);
        tempo();
        click(clicaPratoMateriaPrima);
        tempo();
        tempo();
        click(btnVoltar);
        tempo();
        click(btnVoltar);
        tempo();
        click(btnVoltar);
        tempo();


    }

    public void atualizaDataReferencia(String CDSERVICO, String DATAREF) {
        tempo();
        click(btnAcoes);
        tempo();
        click(atualizaDataRef);
        click(btnTodos);
        click(campoServico);
        // click(lupaFiltro);
        click(informaServico);
        sendKeys(informaServico, CDSERVICO);
        click(confirmServico);
        click(btnOk);
        click(limpaDataRef);
        click(calendarDtRef);
        tempo();
        click(selecionaDtReferencia);
        click(btnAtualizar);
        click(confirmaDataReferencia);
        tempo();
        click(botaoOkMsg);
        tempo();
    }

    public void atualizaDataRecalculoCusto(String CDSERVICO) {
        click(btnAcoes);
        tempo();
        click(btnAtualizaDtRecalculoCusto);
        click(btnTodos);
        click(campoServico);
        // click(lupaFiltro);
        click(informaServico);
        sendKeys(informaServico, CDSERVICO);
        click(confirmServico);
        click(btnOk);
        click(limpaDataRef);
        click(calendarDtRef);
        tempo();
        click(selecionaDtReferencia);
        click(btnAtualizar);
        click(confirmaDataReferencia);
        tempo();

    }

    public void consultaNutrientes() {
        click(btnAcoes);
        tempo();
        click(btnConsulaNutriente);
        tempo();
        click(btnCalculaNutriente);
        tempo();
        click(btnVoltar);
        tempo();
        click(btnCalendario);
        tempo();
        click(diaCalculoNutriente);
        tempo();
        click(btnCalculaNutriente);
        tempo();
        click(btnVoltar);
        tempo();
        click(btnVoltar);
        tempo();

    }

    public void copiarPrato(String CDPRATO, String COMENSAISSEG, String COMENSAISTER, String COMENSAISQUA, String COMENSAISQUI, String COMENSAISSEX, String COMENSAISSAB, String COMENSAISDOM, String COMENSAISFER) {
        click(btnAcoes);
        click(btnCopiaPratoComensais);
        click(limpaCampoServico);
        click(lupaPratoOrigem);
        //  click(lupaFiltro);
        click(informaPrato);
        sendKeys(informaPrato, CDPRATO);
        click(selecionaPrato);
        click(comensaisSeg);
        sendKeys(comensaisSeg, COMENSAISSEG);
        click(comensaisTer);
        sendKeys(comensaisTer, COMENSAISTER);
        click(comensaisSQuar);
        sendKeys(comensaisSQuar, COMENSAISQUA);
        click(comensaisQuin);
        sendKeys(comensaisQuin, COMENSAISQUI);
        click(comensaisSex);
        sendKeys(comensaisSex, COMENSAISSEG);
        click(btnAcoes);
        click(btnCopiarPratos);
        tempo();
        click(confirmaMensagem);
        tempo();

    }

    public void copiarComensais(String CDPRATO) {
        click(btnAcoes);
        click(btnCopiaPratoComensais);
        click(lupaPratoOrigem);
        click(informaPrato);
        sendKeys(informaPrato, CDPRATO);
        click(selecionaPrato);
        click(btnAcoes);
        click(btnCopiaComensais);
        tempo();
        click(confirmaMensagem);
        tempo();

    }

    public void exportarCardapio(String DTINI, String DTFIM, String CDSERVICO) {
        tempo();
        tempo();
        click(btnAcoes);
        click(btnExportarCardapio);
        tempo();
        click(calendarDtRef);
        tempo();
        click(clicaAno);
        tempo();
        click(btnProximoMes);
        tempo();
        click(selecionaMesDestinoExportacao);
        tempo();
        click(periodoInicial);
        tempo();
        click(periodoFinal);
        click(btnOK);
        tempo();
        click(checkBoxCopiarComOrig);
        tempo();
        click(marcaServicoDestino);
        tempo();
        click(btnExportar);
        click(confirmaMensagem);
        click(btnVoltar);
        click(limpaFiltroServico);
        click(filtroServico);
        click(informaServico);
        sendKeys(informaServico, CDSERVICO);
        tempo();
        click(confirmaServico);
        confirmaFiltro();
        tempo();
        tempo();
        ScrollTela();
        tempo();

    }

    public void exportaCardapioSobrepondo(String CDSERVICO){
        tempo();
        click(btnAcoes);
        click(btnExportarCardapio);
        tempo();
        click(calendarDtRef);
        tempo();
        click(clicaAno);
        tempo();
        click(btnProximoMes);
        tempo();
        click(selecionaMesDestinoExportacao);
        tempo();
        click(periodoInicial);
        tempo();
        click(periodoFinal);
        click(btnOK);
        tempo();
         click(radioButtonSobrepor);
        click(marcaServicoDestino);
        tempo();
        click(btnExportar);
        click(confirmaMensagem);
        click(btnVoltar);
        click(limpaFiltroServico);
        click(filtroServico);
        click(informaServico);
        sendKeys(informaServico, CDSERVICO);
        tempo();
        click(confirmaServico);
        confirmaFiltro();
        tempo();
        tempo();
        ScrollTela();
        tempo();
    }

    public void importarCardapioDia(String CDFILIAL, String CDSERVICO, String CDSERVICOORIGEM, String DTINICIAL, String DTFINAL, String DTDESTINO) {
        click(btnVoltar);
        click(limpaFiltroServico);
        click(filtroServico);
        click(informaServico);
        sendKeys(informaServico, CDSERVICO);
        tempo();
        click(confirmaServico);
        confirmaFiltro();
        click(btnAcoes);
        click(btnImportarCardapio);
        click(lupaFilial);
        sendKeys(informaFilial, CDFILIAL);
        tempo();
        click(selecionaFilial);
        click(filtroServico);
        click(informaServico);
        sendKeys(informaServico, CDSERVICOORIGEM);
        tempo();
        click(confirmaServico);
        click(dtInicialOrigem);
        sendKeys(dtInicialOrigem, DTINICIAL);
        click(dtFinalOrigem);
        sendKeys(dtFinalOrigem, DTFINAL);
        click(dtDestino);
        sendKeys(dtDestino, DTDESTINO);
        click(radioSobrepor);
        click(btnFiltrar);
        tempo();
        click(btnImportar);
        tempo();
        click(confirmaMensagem);
        tempo();
    }

    public void importarTipoPrato(String CDFILIAL, String CDSERVICO, String DTINICIO) {
        click(btnAcoes);
        click(btnImportaTipoPrato);
        click(btnLimpaCampo);
        click(confirmaMensagem);
        click(lupaFilial);
      //  click(lupaFiltro);
        tempo();
        click(informaFilial);
        sendKeys(informaFilial, CDFILIAL);
        click(confirmaFilial);
        click(confirmaMensagem);
        tempo();
        click(filtroServico);
        click(informaServico);
        sendKeys(informaServico, CDSERVICO);
        tempo();
        click(confirmaServico);
        click(confirmaMensagem);
        click(campoMesCardapio);
        click(mesCardapio);
        click(dtInicioDestino);
        sendKeys(dtInicioDestino, DTINICIO);
        click(ckeckBoxCopiaComCardapioOrig);
        click(tipoPratoAcrescentar);
        click(marcaTipoPrato);
        click(btnOK);
        click(btnImportarTipoPrato);
        tempo();
        click(confirmaImportacao);
        tempo();
        click(confirmaMensagem);
        tempo();
        tempo();
        scrillvertival();
        tempo();

    }

    public void excluirCardapioPeriodo(String DTINICIAL, String DTFINAL) {
        click(btnAcoes);
        javaScriptExecutor.executeScript("document.querySelector('#popup > span > section > section > section > div > div').scrollBy(0,100)");
        click(btnExcluirCardapioPeriodo);
        click(limpaDataInicial);
        click(dataInicial);
        sendKeys(dataInicial, DTINICIAL);
        click(limpaDataFinal);
        click(dataFinal);
        sendKeys(dataFinal, DTFINAL);
        click(listaTipoPrato);
        tempo();
        click(checkTipoPratoTodos);
        tempo();
        click(confirmaExclusaoCardPeriodo);
        tempo();
        click(btnOK);
        tempo();
        click(btnExcluir);
        tempo();
        click(confirmaExclusaoCardPeriodo);
        tempo();
        tempo();
        tempo();

    }

    public void configurarCardapio() {
        tempo();
        click(btnAcoes);
        tempo();
        javaScriptExecutor.executeScript("document.querySelector('#popup > span > section > section > section > div > div').scrollBy(0,100)");
        click(btnConfigurarCardapio);
        tempo();
        click(tipoDePrato1);
        tempo();
        click(tipoDePrato2);
        tempo();
        click(tipoDePrato3);
        tempo();
        click(btnExcluirTipoPratos);
        tempo();
        click(btnConfirmaExclusao);
        tempo();
        tempo();
        click(btnVoltar);
        tempo();

    }

    public void invertarPrato(String NMPRATO, String NMPRATO01, String DTORIGEM, String DTDESTINO) {
        tempo();
        duploClique(tipoPrato01);
        tempo();
        click(nmPrato);
        tempo();
        sendKeys(nmPrato, NMPRATO);
        tempo();
        click(clicarGrid);
        tempo();
        click(clicaPrato);
        click(copiarSubsPratoSeg);
        tempo();
        click(btnSalvar);
        tempo();
        duploClique(tipoPrato05);
        tempo();
        click(nmPrato);
        sendKeys(nmPrato, NMPRATO01);
        tempo();
        click(clicarGrid);
        tempo();
        click(clicaPrato);
        click(copiarSubsPratoTer);
        tempo();
        click(btnSalvar);
        tempo();
        tempo();
        click(btnAcoes);
        tempo();
        javaScriptExecutor.executeScript("document.querySelector('#popup > span > section > section > section > div > div').scrollBy(0,100)");
        click(btnInverterPrato);
        click(dtPratoOrigem);
        sendKeys(dtPratoOrigem, DTORIGEM);
        click(dtPratoDestino);
        sendKeys(dtPratoDestino, DTDESTINO);
        tempo();
        click(ckeckBoxManterComensalDia);
        click(btnInverter);
        click(confirmaMensagem);
        tempo();
        ScrollTela();
        tempo();
        tempo();

    }

    public void excluirPrato() {
        click(btnVoltar);
        click(limpaFiltroServico);
        click(filtroServico);
        click(informaServico);
        sendKeys(informaServico, "00001");
        tempo();
        click(confirmaServico);
        tempo();
        confirmaFiltro();
        tempo();
        duploClique(tipoPrato01);
        tempo();
        click(btnExcluirPrato);
        tempo();
        click(btnConfirmaExclusao);
        tempo();
        tempo();
    }

    public void informacaoNutricional() {
        tempo();
        tempo();
        duploClique(tipoPrato01);
        tempo();
        click(btnInformacaoNutricional);
        tempo();
        tempo();
        tempo();
        tempo();
        click(btnVoltar);
        tempo();
        click(btnCancelar);
        tempo();

    }

    public void revisaoReceitaLocal() {
        tempo();
        click(tipoPrato01);
        click(tipoPrato01);
        click(btnRevisarReceita);
        click(btnReceitaLocal);
        tempo();
        click(btnImportarReceita);
        click(tipoReceita);
        tempo();
        click(opcaoPadrao);
        tempo();
        click(btnRealizaImportacao);
        tempo();
        click(importacaoAcrescentar);
        tempo();
        click(btnVoltar);
        click(btnSalvar);
        tempo();
    }

    public void revisaoReceitaPorServico() {
        Actions actions = new Actions(driver);
        tempo();
        click(tipoPrato01);
        click(tipoPrato01);
        tempo();
        click(btnRevisarReceita);
        click(btnReceitaPorServico);
        tempo();
        click(btnImportarReceitaServico);
        click(tipoReceita);
        tempo();
        click(opcaoLocal);
        tempo();
        actions.moveToElement(driver.findElement(campoUnidade), -100, 0).click().build().perform();
        tempo();
        click(filialOrigem);
        tempo();
        click(btnRealizaImportacao);
        tempo();
        click(importacaoAcrescentar);
        tempo();
        click(btnVoltar);
        tempo();
        click(btnSalvar);
        tempo();
    }

    public String validaPratoCardapio(){
        return getText(validaPratoCardapio);
    }

}