package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.GrupoServicosFlows;
import com.javaseleniumtemplate.pages.GrupoServicosPage;
import org.testng.annotations.Test;

public class GrupoServicosTests extends TestBase {

    GrupoServicosPage grupoServicosPage;
    GrupoServicosFlows grupoServicosFlows;
    LoginFlows loginFlows;

    //verificar os campos obrigatórios da tela
    //tentar adicionar um grupo de serviço, com um código que já exista e verificar na tela qual mensagem é exibida
    //adiconar, editar e excluir um grupo de serviços
    @Test
    public void adicionarGrupoServico() {
        grupoServicosPage = new GrupoServicosPage();
        grupoServicosFlows = new GrupoServicosFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        grupoServicosFlows.navegateRelaGrupoServicos();
        grupoServicosPage.camposObrigatorios();
        grupoServicosPage.refresh();
        grupoServicosPage.adicionarCodigoExistente();
        grupoServicosPage.refresh();
        grupoServicosPage.adicionarGrupo();
        grupoServicosPage.editarGrupo();
        grupoServicosPage.excluir();

        try {
            Thread.sleep(5000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //acessar a aba 'serviço' de algum grupo de serviço já adicionado
    //verificar o código e nome do serviço que faz parte do grupo de serviços que foi acessado
    //editar o campo 'Ordenação Transporte' e tentar adicionar letras e caracteres especiais. Deve ser permitido apenas número
    //alterar o valor para um número e salvar, a operação deve ser realizada com sucesso
    @Test
    public void verificacaoDaAbaServico() {
        grupoServicosPage = new GrupoServicosPage();
        grupoServicosFlows = new GrupoServicosFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        grupoServicosFlows.navegateRelaGrupoServicos();
        grupoServicosPage.verificarAbaServico();

        try {
            Thread.sleep(5000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }


}
