package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.RequisicaoPorServicoFlows;
import com.javaseleniumtemplate.pages.RequisicaoPorServicoPage;
import org.testng.annotations.Test;

public class RequisicaoPorServicoTests extends TestBase {

    RequisicaoPorServicoPage requisicaoPorServicoPage;
    RequisicaoPorServicoFlows requisicaoPorServicoFlows;
    LoginFlows loginFlows;

    //preencher o filtro inicial
    //preencher o formulário para adicionar um novo tipo de prato e verificar o tipo de prato adcionado
    //editar a quantidade do produto adicionado
    //adicionar um segundo produto ao mesmo prato
    //inserir e editar uma mensagem, na requisição de tipo de prato
    //excluir o tipo de prato adicionado
    @Test
    public void requisicaoTipoPrato() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroIni("Tipo de Prato");
        requisicaoPorServicoPage.preencherFormTipoPrato();
        requisicaoPorServicoPage.verificarTipoPratoAdd();
        requisicaoPorServicoPage.editarQuantidadeProd();
        requisicaoPorServicoPage.verificarEdicaoProd();
        requisicaoPorServicoPage.adicionarProd();
        requisicaoPorServicoPage.verificarProdAdd();
        requisicaoPorServicoPage.inserirMensagem("Tipo de Prato");
        requisicaoPorServicoPage.limparCampoMensagem("Tipo de Prato");
        requisicaoPorServicoPage.excluirTipoPrato();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //preencher o filtro inicial
    //verificar os campos obrigatórios do formulário para adicionar o tipo de prato
    //preencher os campos obrigatórios
    //salvar o tipo de prato e excluir o mesmo
    @Test
    public void verificarCampoObrigatorioFormTipoPrato() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroIni("Tipo de Prato");
        requisicaoPorServicoPage.verificarMensObrigaFormTipoPrato();
        requisicaoPorServicoPage.selecionarCamposObrigatoriosFormTipoPrato();
        requisicaoPorServicoPage.excluirTipoPrato();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //preencher filtro inicial
    //preencher o formulário para adicionar uma requisição de produto e verificar o produto adicionado
    //inserir, editar e apagar uma mensagem, na requisição de produto
    //editar a quantidade do produto
    //excluir produto
    @Test
    public void requisicaoProduto() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroIni("Produto");
        requisicaoPorServicoPage.preencherFormProduto();
        requisicaoPorServicoPage.verificarProdutoAdd();
        requisicaoPorServicoPage.inserirMensagem("Produto");
        requisicaoPorServicoPage.limparCampoMensagem("Produto");
        requisicaoPorServicoPage.editarQuantProduto();
        requisicaoPorServicoPage.excluirProduto();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //verificar compos obrigatórios no formulário para adicionar uma requisição de produto
    @Test
    public void verificarCampoObrigatorioFormProduto() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroIni("Produto");
        requisicaoPorServicoPage.verificarMensObrigaFormProduto();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //verificar campos obrigatórios do filtro inicial da tela e na sequência preencher estes campos e aplicar o filtro
    @Test
    public void verificarObrigatorioFiltroIni() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateRequisicaoPorServico();
        requisicaoPorServicoPage.verificarCamposObrigFiltroInicial();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //verificar os campos obrigatórios na tela de geração dos relatórios
    @Test
    public void verificarObrigatorioTelaRelatorio() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroIni("Produto");
        requisicaoPorServicoPage.verificarObrigatorioTelaRelatorio();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //realizar o cálculo da requisição de um tipo de prato
    @Test
    public void calculoRequisicao() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroIniParaCalcular();
        requisicaoPorServicoPage.calcularRequisicao();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //verificar se o campo "Ponto de Entrega" está habilitado apenas quando o relatório ""Requisição por Serviço/Ponto de Entrega (Analítico)" está selecionado
    @Test
    public void verificarCampoPontoEntregaHabilitado() {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroIni("Tipo de Prato");
        requisicaoPorServicoPage.acessarTelaRelatorio();
        requisicaoPorServicoPage.verificarCampoPontoEntrega();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }
    
    @Test
    public void relatorioRequiServico() {
        gerarRelatorio("Requisição por Serviço", "Código");
    }

    @Test
    public void relatorioRequiServicoTurnos() {
        gerarRelatorio("Requisição por Serviço (Turnos)", "Código");
    }

    @Test
    public void relatorioRequiOperador() {
        gerarRelatorio("Requisição por Operador", "Código");
    }

    @Test
    public void relatorioRequiPontoEntregaAnalitico() {
        gerarRelatorio("Requisição por Serviço/Ponto de Entrega (Analítico)", "Código");
    }

    @Test
    public void relatorioGrupoServicoAnalitico() {
        gerarRelatorio("Requisição por Grupo de Serviço (Sintético)", "Alfabética Pelo Nível");
    }

    @Test
    public void relatorioRequiServicoTipoPrato() {
        gerarRelatorio("Requisição por Serviço (Tipo de Prato/Prato)", "Alfabética Pelo Nível");
    }

    @Test
    public void relatorioRequiUnidadeAdicional() {
        gerarRelatorio("Requisição por Serviço (Unidade Adicional)", "Alfabética Pelo Nível");
    }

    //gerar todos os relatórios com os campos (grupo de serviço, serviço, ponto de entrega e tipo de consumo) marcados com a opção 'Todos'
    //gerar todos os relatórios com os campos (grupo de serviço, serviço, ponto de entrega e tipo de consumo), preenchidos de forma manual
    public void gerarRelatorio(String nomeRelatorio, String ordenacao) {
        requisicaoPorServicoPage = new RequisicaoPorServicoPage();
        requisicaoPorServicoFlows = new RequisicaoPorServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoPorServicoFlows.navegateRequisicaoPorServico();
        requisicaoPorServicoPage.preencherFiltroIni("Tipo de Prato");
        requisicaoPorServicoPage.acessarTelaRelatorio();
        requisicaoPorServicoPage.selecionarRelatorio(nomeRelatorio);
        requisicaoPorServicoPage.preencherDatas("01/07/2022", "31/07/2022");
        requisicaoPorServicoPage.selecionarUnidadeDepositoJabaquara();
        requisicaoPorServicoPage.gerarRelatorio();
        requisicaoPorServicoPage.selecionarGrupoServico();
        requisicaoPorServicoPage.selecionarServicos();
        requisicaoPorServicoPage.selecionarPontoEntrega(nomeRelatorio);
        requisicaoPorServicoPage.selecionarCaracteristicasRelatorio(nomeRelatorio);
        requisicaoPorServicoPage.selecionarTipoConsumo();
        requisicaoPorServicoPage.selecionarOrdenacao(ordenacao);
        requisicaoPorServicoPage.gerarRelatorio();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

}
